Bug 449946

Summary: dhcpd ignoring secondary IPs
Product: [Fedora] Fedora Reporter: Christian Celler <celler>
Component: dhcpAssignee: Jiri Popelka <jpopelka>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: low Docs Contact:
Priority: low    
Version: rawhideCC: igeorgex, joshua, scott.m.mcdermott+rh-omnisys-bugs
Target Milestone: ---Keywords: Reopened, Triaged
Target Release: ---   
Hardware: i386   
OS: Linux   
Whiteboard:
Fixed In Version: dhcp-4.2.3-24.P2.fc17 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2012-05-23 05:26:52 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 803540    
Attachments:
Description Flags
dhcpd.conf none

Description Christian Celler 2008-06-04 08:46:04 EDT
Description of problem:
dhcpd does not start if "subnet"-declaration does not match the primary
ip-address of an interface.

Version-Release number of selected component (if applicable):
dhcp-4.0.0-14.fc9.i386

How reproducible:
Setup a machine with a secondary IP on an interface. Use this IP as "subnet" in
dhcpd.conf.


Steps to Reproduce:
1. install dhcp
2. configure a secondary ip for an interface
3. use this IPs network as subnet-declaration
4. start dhcpd
  
Actual results:
Server does not start.

Expected results:
Server should start.

Additional info:
[root@powell ~]# ip addr list dev eth0
2: eth0: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc pfifo_fast state UP
qlen 1000
    link/ether 00:e0:81:76:ae:4d brd ff:ff:ff:ff:ff:ff
    inet yy.yyy.16.252/24 brd yy.yyy.16.255 scope global eth0
    inet 192.168.204.2/24 brd 192.168.204.255 scope global eth0
[root@powell ~]# ip addr list dev eth1
3: eth1: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc pfifo_fast state UP
qlen 1000
    link/ether 00:e0:81:76:ae:4c brd ff:ff:ff:ff:ff:ff
    inet xxx.xx.46.252/23 brd xxx.xx.47.255 scope global eth1
    inet 192.168.206.2/23 brd 192.168.207.255 scope global eth1
Comment 1 Christian Celler 2008-06-04 08:46:04 EDT
Created attachment 308337 [details]
dhcpd.conf
Comment 2 David Cantrell 2008-09-29 17:46:36 EDT
This is definitely a valid problem and an interesting one to solve.  The ISC dhcp software uses ioctl() calls to gather network interface information.  Those calls do not give the caller anything but the first or primary IPv4 address.

To see all addresses per interface on Linux, dhcpd will have to be patched to use libnl to get a list of all addresses via Netlink.  I'm not sure if that would be accepted upstream, but we can try.
Comment 3 Christian Celler 2008-09-30 07:48:55 EDT
The work-around would be to use shared-network statements with an empty subnet-definition for the "primary" address and then to configure the "real" subnet as usual in this shared-network.
Comment 4 Bug Zapper 2009-06-09 21:23:59 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Bug Zapper 2009-11-16 03:07:20 EST
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Bug Zapper 2010-11-04 07:53:37 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Jiri Popelka 2012-03-15 07:18:35 EDT
Previous URL is wrong, correct one is:
https://lists.isc.org/pipermail/dhcp-hackers/2011-June/001920.html
Comment 9 Jiri Popelka 2012-03-21 12:23:55 EDT
We could possibly use getifaddrs() instead of the Netlink code in patch mentioned in previous comment. That would simplify the discovery code *a lot*.
Comment 10 Fedora Update System 2012-03-21 15:01:16 EDT
dhcp-4.2.3-22.P2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/dhcp-4.2.3-22.P2.fc17
Comment 11 Fedora Update System 2012-03-22 20:43:53 EDT
Package dhcp-4.2.3-22.P2.fc17:
* should fix your issue,
* was pushed to the Fedora 17 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing dhcp-4.2.3-22.P2.fc17'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-4532/dhcp-4.2.3-22.P2.fc17
then log in and leave karma (feedback).
Comment 12 Fedora Update System 2012-03-23 14:18:37 EDT
dhcp-4.2.3-23.P2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/dhcp-4.2.3-23.P2.fc17
Comment 13 Fedora Update System 2012-04-11 22:35:12 EDT
dhcp-4.2.3-24.P2.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 14 joshua 2012-05-22 15:09:20 EDT
Can we get this fixed and pushed to Fedora 15 and 16 as well please?  This is a bug in those releases as well
Comment 15 Jiri Popelka 2012-05-23 05:26:52 EDT
No. The patch is not well tested and I won't risk breaking someone's dhclient/dhcpd in F16 or even F15.